+v        =53248
+irr      =v+25
+irm      =v+26

         .setpc $ec00
        ;.buffer ($8e00,$a000)
         .putobject "obj.story"
         .begin
          jmp irqinit

+reset    lda#0
          jmp send
+settrs   sty lade2+1
          txa
          jsr send
          nop
          nop
          nop
-lade2    lda#0
          jsr send
          lda#0
          sta $dd00
          rts
+readbl   lda $dd00
          bmi readbl
          ldy#5
          dey
          bne *-1
-cb5      jsr readbyte
          sta 1024,y
          iny
          bne cb5
          rts
+send     sta byte+1
          ldx#4
-se1      asl byte+1
          rol
          asl byte+1
          rol
          and#3
          tay
          nop
          nop
          nop
          lda sendtab,y
          sta $dd00
          and#255-8
          bit 0
          nop
          sta $dd00
          dex
          bne se1
          rts
-sendtab
         .b %00001000
         .b %00011000
         .b %00101000
         .b %00111000
+readbyte ldx#4
-re1      lda#8
          sta $dd00
          nop
          nop
          bit 0
          lda#0
          sta $dd00
          nop
          nop
          nop
          lda $dd00
          asl
          rol
          rol byte+1
          lsr
          rol byte+1
          dex
          bne re1
-byte     lda#0
          rts
         .end


+quellscreen   =$f000
+zielscreen    =$f400
+si            =54272
+v   =53248
+irr =v+25
+irm =v+26
+fbl =232
+p0  =1016+zielscreen
+p1  =p0+1
+p2  =p1+1
+p3  =p2+1
+p4  =p3+1
+p5  =p4+1
+p6  =p5+1
+p7  =p6+1
+irqinit
          lda#<i
          ldx#>i
        sta $fffe
        stx $ffff
       ;sta $314
       ;stx $315
          ldx#1
          stx irm
          dex
          stx 53266
          stx 56576
          stx v+38
          stx v+39
          stx v+40
          stx v+41
          stx v+42
          stx v+43
          stx v+44
          stx v+45
          stx v+46
          stx sourcpt
          stx sourcpt+1
          stx textoutflag
          stx si+5
          stx si+6
          stx si+7+4
          stx si+14+4
          txa
-iri1     sta 55296,x
          sta 55296+256,x
          sta 55296+512,x
          sta 55296+768,x
          dex
          bne iri1
          dex
          stx v+28
          stx v+21
          stx v+27
          lda#>quellscreen
          sta read+2
          lda#>zielscreen
          sta write+2
          lda#8
          sta v+37
          lda#12
          sta 53280
          sta 53281
          asl
          sta v
          sta v+4
          sta v+8
          sta v+12
          asl
          sta v+2
          sta v+6
          sta v+10
          sta v+14
          lda#41
          sta si+1
          lda#15
          sta si+24

          lda#222
          sta 53272
          lda#200
          sta 53270
          lda#27
          sta 53265
          cli
+load
          ldx#19         ; track
          ldy#0          ; sektor
          jsr settrs
          jsr readbl
          lda#<(2049-4)
          sta $fa
          lda#>(2049-4)
          sta $fb
          ldx 1024
          ldy 1025
          jsr settrs
-lo3      ldy#4
-l1       lda 1024,y
          sta ($fa),y
          iny
          bne l1

          jsr readbl
          lda#<2299
          sta $fa
          lda#>2299
          sta $fb
-l2       ldx 1024
          beq l4
          ldy 1025
          jsr settrs

-l4       ldy#2
-l3       lda 1024,y
          sta ($fa),y
          iny
          bne l3
          clc
          lda#254
          adc $fa
          sta $fa
          bcc l5
          inc $fb
-l5       ldx 1024
          beq ende
          jsr readbl
          jmp l2

-ende     jsr reset
          ldy#0
          ldx#0
-txin1    lda sptab,x
          sta 49152+fbl*64+128,y
          lda sp2tab,x
          sta 49152+fbl*64+256,y
          inx
          lda sptab,x
          sta 49152+fbl*64+384,y
          lda sp2tab,x
          sta 49152+fbl*64+512,y
          iny
          iny
          iny
          inx
          cpy#63
          bcc txin1

          lda#16
-waitf    and 56320
          and 56321
          bne waitf
           alles zuruecksetzen
          sta v+21
          sta irm
          sei
          sta irr
          lda#$31
          ldx#$ea
          sta $314
          stx $315
          lda#3
          sta 56576
          lda#27
          sta 53265
          lda#200
          sta 53270
          ldy#6
-ende1    lda einsprung,y
          sta 828,y
          dey
          bpl ende1
          jmp 828
-einsprung     lda#55
          sta 1
          jmp 2061

-sptab
         .b %11110100,%11111100
         .b %11001100,%11000000
         .b %11001100,%11110000
         .b %11110100,%11000000
         .b %11000000,%11000000
         .b %11000000,%11000000
         .b %11000000,%00000000
         .b %00000000,%11000000
         .b %11110100,%11000000
         .b %11001100,%11000000
         .b %11001100,%11000000
         .b %11110000,%11000000
         .b %11001100,%11000000
         .b %11001100,%11000000
         .b %11001100,%00000000
         .b %00000000,%11110100
         .b %11111100,%11001100
         .b %11000000,%11001100
         .b %11110000,%11110000
         .b %11000000,%11001100
         .b %11000000,%11001100
-sp2tab
         .b %11111100,%11001100
         .b %00000000,%00000000
         .b %01111100,%11111100
         .b %11000000,%11000000
         .b %11110100,%11110000
         .b %00001100,%11000000
         .b %00001100,%11000000
         .b %11110100,%11111100
         .b %00000000,%00000000
         .b %01111100,%00000000
         .b %11000000,%00000000
         .b %11110100,%00000000
         .b %00001100,%00000000
         .b %00001100,%00000000
         .b %11110100,%00000000
         .b %00000000,%00000000
         .b %00000000,%00000000
         .b %00000000,%00000000
         .b %00000000,%00000000
         .b %00000000,%00000000
         .b %00000000,%00000000

+i      pha
        txa
        pha
          lda $dc0d
          bpl rirq
        pla
        pla
        rti
       ;jmp $ea81
-rirq     jmp rt1

-rt1      lda#50
          sta v+1
          sta v+3
          lda#71
          sta v+5
          sta v+7
          lda#92
          sta v+9
          sta v+11
          lda#113
          sta v+13
          sta v+15
          ldx#fbl
          stx p0
          inx
          stx p1
          inx
          stx p2
          inx
          stx p3
          inx
          stx p4
          inx
          stx p5
          inx
          stx p6
          inx
          stx p7
          lda#<rt2
          ldx#>rt2
          sta rirq+1
          stx rirq+2
          lda#115
          sta 53266
          dec flashcnt
          bne ire1
          lda#16
          sta flashcnt
          lda#1
          eor v+38
          sta v+38
-ire1     jmp irend

-rt2      lda#134
          sta v+1
          sta v+3
          lda#155
          sta v+5
          sta v+7
          lda#176
          sta v+9
          sta v+11
          ldx#fbl+8
          stx p0
          inx
          stx p1
          inx
          stx p2
          inx
          stx p3
          inx
          stx p4
          inx
          stx p5
          lda#<rt3
          ldx#>rt3
          sta rirq+1
          stx rirq+2
          lda#180
          sta 53266
          jmp irend

-rt3      lda#197
          sta v+1
          sta v+3
          lda#218
          sta v+5
          sta v+7
          ldx#fbl+14
          stx p0
          inx
          stx p1
          inx
          stx p2
          inx
          stx p3
          lda#<rt1
          ldx#>rt1
          sta rirq+1
          stx rirq+2
          lda#0
          sta 53266

          lda textoutflag
          bne tx2
          inc sourcpt
          bne tx1
          inc read+2
          inc write+2
          inc sourcpt+1
-tx1
          ldx sourcpt
          lda sourcpt+1
          cpx#<1000
          bne read
          cmp#>1000
          bne read
          inc textoutflag
-read     lda $3000,x
-write    sta $3400,x
          cmp#32
          beq tx2
          lda#16
          sta si+4
          lda#17
          sta si+4
-tx2
          jmp irend

+irend
          dec irr
        pla
        tax
        pla
        rti
       ;jmp $ea81

-sourcpt      .w 0
-textoutflag  .b 0
-flashcnt     .b 0
